package com.meiyou.service.handler.flutter;

import com.meiyou.service.handler.Message;
import com.meiyou.service.handler.MessageDispatcher;
import com.meiyou.service.handler.MessageHandler;
import com.meiyou.service.handler.MessageResult;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FlutterMessageDispatcher implements MessageDispatcher {

    private Map<String, MessageHandler> _handlers = new HashMap<>();

    private Object mContenxt;

    @Override
    public void dispatch(Message msg, MessageResult result) {
        if (msg != null && result != null){
            MessageHandler  handler = _handlers.get(msg.name());
            if(handler != null){
                handler.onMethodCall(msg.name(),(Map) msg.arguments(),result);
            }
        }
    }

    @Override
    public void registerHandler(MessageHandler handler) {
        if (handler == null){
            return;
        }

        handler.setContext(this.getContext());

        List<String> messages = handler.handleMessageNames();
        for(String name : messages){
            if(_handlers.get(name) == null){
                _handlers.put(name,handler);
            }else{
                assert(false):"Register mutiple handlers for same key result in undeined error!";
            }
        }

    }

    @Override
    public void removeHandler(MessageHandler handler) {
        if (handler != null){
            List<String> messages = handler.handleMessageNames();
            for(String name : messages) {
                _handlers.remove(name);
            }
        }
    }

    @Override
    public void removeAll() {
        _handlers.clear();;
    }

    @Override
    public Object getContext() {
        return mContenxt;
    }

    @Override
    public void setContext(Object obj) {
        mContenxt = obj;
    }
}
