package com.meiyou.service.service;

import com.meiyou.service.handler.MessageHandler;

import java.util.HashMap;
import java.util.Map;

public class ServiceGateway {

    private  static final  ServiceGateway instance = new ServiceGateway();

    private Map<String,Service> mServices = new HashMap<>();

    public static ServiceGateway sharedInstance(){
        return instance;
    }

    public void addService(Service serivice){
        if (serivice != null){
            mServices.put(serivice.serviceName(),serivice);
            serivice.start();
        }
    }

    public void registerHandler(MessageHandler handler){
        mServices.get(handler.service()).registerHandler(handler);
    }

    public void removeService(Service service){
        if (service != null){
            mServices.remove(service.serviceName());
            service.end();
        }
    }

}
